Bienvenue dans l'aide de WinComposer

Présentation générale
Wincomposer est un assembleur d'icônes, à savoir un outil destiné à assembler (composer) des icônes à partir de ressources graphiques. Ce n'est pas à proprement parler un éditeur d'icônes, en ce sens que WinComposer ne propose pas les outils d'édition offerts par des utilitaires spécialisés ou par les grands programmes graphiques tels que Photoshop.

Interface utilisateur
WinComposer offre une interface utilisateur construite autour de la notion d'importation de ressources graphiques. Ces ressources sont affichées dans un premier onglet, appelé Assembleur d'icônes. C'est à partir de là que sont produits les fichiers de sortie.
Vous pouvez aussi, naturellement, copier des données depuis d'autres applications graphiques en utilisant le presse-papiers.
Pour en savoir plus.

Ressources graphiques acceptées en entrée
WinComposer permet d'importer de très nombreuses ressources graphiques, telles que des fichiers d'icônes, des bitmaps, des fichiers JPEG, etc. Le contenu de ces fichiers est affiché dans l'Assembleur d'icônes (onglet principal, voir ci-dessus).
Pour en savoir plus.

Fichiers produits en sortie
À partir de ces images affichées dans l'onglet d'assemblage, WinComposer vous permet de sauvegarder des icônes pour Windows, pour Macintosh, ainsi que d'autres formats graphiques.
Pour en savoir plus.


Interface utilisateur

Introduction
L'interface utilisateur de WinComposer est organisée en trois onglets :

  • Assembleur d'icônes, où sont assemblées (composées) les icônes,
  • Table de montage, où sont affichées toutes les ressources graphiques ouvertes par le programme,
  • Palettes Macintosh, qui affiche les palettes système du Macintosh.

Voir aussi :
Les Menus de WinComposer.
Le Menu contextuel des icônes.


Assembleur d'icônes

Introduction
L'Assembleur d'icônes est l'onglet principal de l'application. C'est là que sont affichées les ressources importées depuis des fichiers ou encore placées par copier-coller (en passant par le presse-papiers).
Dans l'exemple ci-dessus, qui affiche le contenu d'une icône Macintosh à formats multiples, nous avons des icônes de 16*12, 16*16, 32*32, 48*48 et 128*128 pixels, ainsi que leurs masques.
Le programme place automatiquement les ressources importées dans les cases correspondant à leur format, et, s'il existe plusieurs profondeurs de couleur, affiche la meilleure.
Afin de vous permettre de vous rendre compte de ce qu'il y avait dans le fichier, notamment dans le cas d'un fichier contenant de multiples formats, tous ces formats sont affichés également sur la Table de montage.

Copier-Coller
Lorsque vous utilisez les commandes classiques de copier-coller, WinComposer opère sur l'image sélectionnée (visualisée par un liseré vert, voir image ci-dessous). Dans ce cas, le programme ne contrôle pas la profondeur de couleur de l'image que vous copiez, et remplace celle qui était affichée.
De même, si l'image que vous collez est trop grande ou trop petite pour la case que vous avez sélectionnée, WinComposer n'exécute pas d'opérations de réduction ou d'agrandissement. Il n'offre pas non plus de fonctions de déplacement de l'image. Vous devez donc préparer les données au préalable dans votre éditeur graphique.

Sélection des icônes
C'est sur l'image repérée par le liseré vert ci-dessus que s'appliquent les très nombreuses fonctions proposées dans le Menu contextuel.

Sauvegarde des icônes
Lorsque les données affichées dans l'Assembleur d'icônes vous conviennent, vous pouvez les sauvegarder ensemble dans un fichier, en passant par le menu Fichier, rubrique Sauvegarder. Voir la page consacrée aux formats de destination pour plus de précisions.
Par ailleurs, le Menu contextuel vous offre de nombreuses options de sauvegarde de chacune des images isolées.


Table de montage

Introduction
La table de montage est une zone de travail où le programme affiche toutes les ressources que vous avez ouvertes, même celles qui n'ont pas été affichées dans l'onglet principal d'assemblage, par exemple parce que la profondeur de couleur était inférieure ou égale à celle d'une image déjà affichée.

Dans l'exemple ci-dessus, on voit ainsi des séries complètes d'images, en 4 bits/pixel, 8 bits/pixel et 32 bits/pixel, ainsi que leurs masques. Par opposition, l'onglet d'assemblage n'affiche que les meilleures images (plus grande profondeur de couleur) :

L'intérêt de cette table de montage est naturellement de vous permettre de vous assurer que vous n'avez pas laissé passer une image qui conviendrait mieux, même si elle est de profondeur inférieure. Vous pouvez dans ce cas copier l'onglet tout entier dans le presse-papiers pour le reprendre dans Photoshop ou dans un autre éditeur graphique.


Palettes Macintosh

Introduction

L'onglet des Palettes Macintosh est essentiellement destiné à vous permettre de voir les différentes palettes système du Macintosh. Contrairement au format des icônes Windows (fichier en *.ico) et plus généralement des bitmaps Windows (fichier *.bmp), les fichiers d'icônes du Macintosh en 16 et en 256 couleurs (4 bits/pixel et 8 bits/pixel) ne contiennent pas leur propre palette, mais font référence à la palette système du Macintosh. Il existe trois de ces palettes :

Palette 16 bits

Palette spéciale des icônes, qui passe à 32 couleurs + 2

Palette 256 couleurs

Cette dernière est naturellement la seule à présenter un intérêt compte tenu de l'évolution des matériels (qui affiche encore en 16 couleurs ?). En disposer vous permettra peut-être de comprendre pourquoi telle icône parfaite sur un PC peut apparaître terne ou virée sur un Mac.
Ces trois palettes peuvent être copiées dans le presse-papiers (CTRL C) lorsqu'elles sont affichées. Cela vous permet par exemple d'utiliser la pipette pour sélectionner les couleurs que vous souhaitez utiliser.


Menus de WinComposer

Introduction
Les menus de WinComposer sont les suivants :

  • Menu Fichier
  • Menu Édition
  • Menu Options
  • Menu Aide

Voir aussi :
Menu contextuel des icônes.


Menu Fichier

Le menu Fichier offre les rubriques suivantes :

  • Importer
    Fonction permettant d'ouvrir des fichiers contenant des ressources graphiques et de les afficher sur l'onglet Assembleur d'icônes
  • Enregistrer
    Fonction permettant de sauvegarder collectivement les différentes icônes affichées sur l'onglet Assembleur d'icônes
  • Configurer l'impression
    Fonction destinée à sélectionner et configurer l'imprimante
  • Imprimer
    Fonction commandant l'impression de la vue courante du programme sur l'imprimante par défaut
  • Quitter
    Fermeture du programme et retour à Windows

Voir aussi :
Menu Édition
Menu Options
Menu Aide
Menu contextuel.


Menu Édition

Le menu Édition offre les rubriques suivantes :

  • Couper
    Fonction copiant le contenu de l'icône sélectionnée dans le presse-papiers et remettant son contenu à zéro.
  • Copier
    Fonction copiant le contenu de l'icône sélectionnée dans le presse-papiers sans remettre son contenu à zéro.
  • Coller
    Fonction copiant le contenu du presse-papiers dans l'icône sélectionnée.
  • Créer tous les masques
    Fonction créant les masques (icônes de droite) pour toutes les icônes en couleurs (icônes de gauche)
  • Effacer
    Fonction supprimant la totalité du contenu de l'onglet courant (onglet Assembleur d'icônes ou Table de montage seulement)

Voir aussi :
Menu Fichier
Menu Options
Menu Aide
Menu contextuel.


Menu Options

Le menu Options offre les rubriques suivantes :

  • Langue
    Rubrique de changement de langue (Anglais/Français)

Voir aussi :
Menu Fichier
Menu Édition
Menu Aide
Menu contextuel.


Menu Aide

Le menu Aide offre les rubriques suivantes :

  • Comment utiliser l'aide
    Affichage d'une petite page expliquant l'organisation de l'aide et les différentes fonctions offertes
  • Accès à l'aide
    Accès au fichier principal d'aide (ce fichier)
  • Recherche dans l'aide
    Appel de la fonction de recherche dans le fichier principal d'aide
  • Index de l'aide
    Appel de l'index (recherche par mots-clefs) du fichier principal d'aide
  • Support technique en ligne
    Accès aux pages de support technique du site www.macdisk.com (ce qui suppose que vous soyez connecté à l'Internet)
  • À propos de WinComposer
    Affichage de la fenêtre classique affichant la version, le numéro de série et nos coordonnées

Voir aussi :
Menu Fichier
Menu Édition
Menu Options
Menu contextuel.


Menu contextuel

Introduction
WinComposer propose un menu contextuel qui est appelé par un clic sur le bouton droit de la souris et dont le contenu varie en fonction du contexte dans lequel il est appelé.

Copier-coller
Les fonctions de copier-coller sont conformes aux usages. La fonction Couper copie le contenu de l'icône sélectionnée dans le presse-papiers et supprime le contenu à l'écran. La fonction Copier fait la même chose, mais laisse le contenu de l'écran inchangé. Enfin, la fonction Coller copie le contenu du presse-papiers dans l'icône sélectionnée.

Profondeur de couleurs
Le sous-menu Profondeur de couleurs vous permet de réduire le nombre de couleurs utilisé pour l'affichage de l'image sélectionnée. Cette fonction peut être utile pour se rendre compte de l'effet. Attention, l'opération ne peut pas être annulée.
Notez bien également que WinComposer n'applique aucun algorithme spécialisé pour ce faire, et que le résultat est nécessairement moins bon que celui que vous pouvez obtenir dans un véritable éditeur graphique.

Rotation de l'image
Il arrive fréquemment qu'une image soit mal affichée (tête en bas, etc.). Ce sous-menu vous permet les opérations classiques de rotation de 180°, de 90° vers la gauche et vers la droite, et enfin d'inversion gauche-droite et haut-bas.

Comptage des couleurs
Cette fonction vous permet de compter le nombre des couleurs différentes utilisées pour l'affichage de l'image sélectionnée.

Prémultiplication
Cette rubrique du menu contextuel vous permet d'appliquer le canal alpha (qui définit la transparence de l'image) aux trois canaux de couleurs de l'image. Cette opération s'appelle la prémultiplication. L'opération inverse s'appelle la démultipliocation.
N'utilisez ces fonctions que si vous savez précisément ce que vous faites.

Enregistrement individuel
Par opposition à la fonction d'enregistrement présente dans le Menu Fichier, qui sauvegarde l'ensemble des images affichées dans l'onglet d'assemblage, cette option ne sauvegarde que l'image sélectionnée.

Voir la page spécialisée sur les Enregistrements individuels pour plus d'informations.

Créer masque
Cette fonction, qui n'est validée que lorsque l'image sélectionnée est une image de masque (images de droite), permet de recalculer le masque à partir de l'image de l'icône (image de gauche).

Voir également :
Menu principal de WinComposer.


Ressources graphiques importées

Formats acceptés
WinComposer accepte en entrée les formats suivants :

  • Fichiers bitmap (extension *.BMP) - Pour en savoir plus
  • Fichiers JPEG (extensions *.JPG, *.JPEG) - Pour en savoir plus
  • Fichiers d'icônes Windows (extension *.ICO) - Pour en savoir plus
  • Conteneurs d'icônes Macintosh (extension *.icns) - Pour en savoir plus
  • Ressources d'icônes Macintosh - Pour en savoir plus
  • Fichiers Apple Single - Pour en savoir plus
  • Fichiers Apple Double - Pour en savoir plus
  • Fichiers BinHex - Pour en savoir plus
  • Fichiers MacBinary - Pour en savoir plus
  • Autres ressources Windows - Pour en savoir plus

Taille des images
En balayant le contenu des fichiers importés, WinComposer recherche les formats suivants :

  • 12*16 pixels (mini icônes)
  • 16*16 pixels (icônes normales)
  • 32*32 pixels (grandes icônes)
  • 48*48 pixels (très grandes icônes)
  • 128*128 pixels (icônes de prévisualisation).

WinComposer n'affiche pas les autres formats d'images. Si vous le souhaitez, vous pouvez cependant utiliser le mécanisme de copier-coller.

Profondeur des couleurs
En balayant le contenu des fichiers importés, WinComposer n'affiche dans les différentes cases de l'onglet Assembleur d'icônes que des images de la taille voulue présentant une meilleure profondeur de couleurs, pour ne pas remplacer une image de qualité par une image moins bonne.
D'autre part, toutes les profondeurs de couleur sont affichées sur la Table de montage.

Importation par copier-coller
WinComposer accepte également l'importation par copier-coller. Cliquez simplement dans l'icône de destination pour la sélectionner et tapez CTRL V.
Attention, WinComposer n'est pas un éditeur graphique et se contente de copier les données du presse-papiers dans le coin supérieur gauche de l'icône. L'image n'est pas redimensionnée, et elle ne peut pas être déplacée.
Vous devez donc préparer les données de manière correcte dans votre éditeur graphique préféré.

Fichiers bitmap (extension *.BMP)
WinComposer accepte tous les formats bitmap, dans toutes les profondeurs de couleurs (1, 4, 8, 24 et 32 bits/pixel).
Retour à la liste des formats

Fichiers JPEG (extensions *.JPG, *.JPEG)
WinComposer accepte tous les formats JPEG. Cependant, la norme JPEG laisse de très nombreux degrés de liberté dans l'organisation des fichiers, et on ne peut donc pas exclure que tel ou tel fichier ne pourra pas être ouvert. Dans ce cas, utiliser le mécanisme du copier-coller depuis une application graphique sachant ouvrir le fichier.
Retour à la liste des formats

Fichiers d'icônes Windows (extension *.ICO)
WinComposer accepte aussi bien les icônes uniques que les fichiers contenant des icônes multiples, dans différentes profondeurs de couleurs (1, 4, 8, 24 et 32 bits/pixel).
Retour à la liste des formats

Conteneurs d'icônes Macintosh (extension *.icns)
Les icônes Macintosh de type 'icns' sont des ressources graphiques qui sont apparues avec le système Mac OS 8 et qui, par rapport aux icônes antérieures (voir ci-dessous), ne sont pas des icônes individuelles, mais un conteneur regroupant une série de formats et de profondeurs de couleur, avec leurs masques.
Voir notre page sur les Icônes Macintosh pour plus d'informations.
Retour à la liste des formats

Ressources d'icônes Macintosh (extensions variables, ou pas d'extension)
Les icônes traditionnelles Macintosh sont stockées dans la Branche de ressources sous la forme d'éléments individuels, dans une sorte de base de données, afin de faciliter l'accès.
Il est possible de trouver dans ces ressources tous les types d'icônes, et toutes les profondeurs de couleur, mais la plupart du temps les icônes modernes sont placées dans des conteneurs de type 'icns' (voir ci-dessus), eux-mêmes stockés dans la branche de ressources ou sous la forme d'un fichier indépendant (sous Mac OS X).
Voir notre page sur les Icônes Macintosh pour plus d'informations.
Retour à la liste des formats

Fichiers Apple Single
Le format Apple Single est une méthode normalisée par Apple pour gérer ensemble (conteneuriser) les deux Branches des fichiers. Les deux branches sont présentes dans le même fichier. La nature réelle du fichier (contenu utile) peut varier.
Voir nos pages sur les Branches des fichiers et sur les Fichiers Macintosh sur l'Internet pour plus d'informations.
Retour à la liste des formats

Fichiers Apple Double
Le format Apple Double format a été normalisé par Apple pour gérer les Branches des fichiers. Les deux branches sont stockés dans deux fichiers distincts. Le premier ne contient que la branche de données. Le second contient la branche de ressources ainsi que les Informations du Finder. La nature réelle du fichier (contenu utile) peut varier.
Voir nos pages sur les Branches des fichiers et sur les Fichiers Macintosh sur l'Internet pour plus d'informations.
Retour à la liste des formats

Fichiers BinHex
La norme de fait BinHex a été créée pour assurer à la fois la conteneurisation des Branches des fichiers, un certain niveau de compression du flux de données et la conversion en caractères sur 7 bits pour assurer la transmission. Les deux branches sont présentes dans le fichier. La nature réelle du fichier (contenu utile) peut varier.
Voir nos pages sur les Branches des fichiers et sur la Norme BinHex pour plus d'informations.
Retour à la liste des formats

Fichiers MacBinary (extension *.BIN, mais pas toujours)
La norme de fait MacBinary a été créée pour associer (conteneuriser) les deux Branches des fichiers. Les deux branches sont présentes dans le fichier. La nature réelle du fichier (contenu utile) peut varier.
Voir nos pages sur les Branches des fichiers et sur la Norme MacBinary pour plus d'informations.
Retour à la liste des formats

Autres ressources Windows (extensions *.EXE, *.DLL, *.IDL, etc.)
WinComposer est en outre en mesure d'ouvrir des ressources Windows pour en extraire les images au format bitmap et les icônes. Il est ainsi possible de récupérer des éléments graphiques dans les applications (*.EXE), dans les DLL (*.DLL) et dans les bibliothèques d'icônes (*.ICL, mais aussi *.IL et *.NIL).
Retour à la liste des formats


Fichiers produits en sortie

Introduction
WinComposer peut enregistrer les ressources graphiques importées en différents formats.

Enregistrement individuel ou groupé ?
Il faut bien distinguer entre deux types d'enregistrement : l'enregistrement individuel, où un fichier ne contient qu'une seule icône, et l'enregistrement groupé, où le fichier contient plusieurs tailles et plusieurs profondeurs de couleurs.

Pour continuer :

  • Enregistrement individuel (fonctions appelées depuis le menu contextuel)
  • Enregistrement groupé (fonctions appelées depuis la rubrique 'Enregistrer' du Menu Fichier)


Branches des fichiers Macintosh

Les deux branches des fichiers Macintosh
Les fichiers Macintosh ne sont pas monolithiques, mais se composent de deux parties, la première appelée "branche de données" (data fork) et la seconde "branche de ressources" (resource fork). Les concepteurs du système d'exploitation du Mac ont ainsi choisi de séparer ce qui est placé dans un seul flux d'octets sur la plupart des autres ordinateurs.
Seule l'une de ces deux branches peut être vide.

Branche de données
La branche de données contient généralement ce que l'on appelle un fichier de données sur le PC. Dans les échanges de fichiers entre Macintosh et PC, il est généralement inutile de s'intéresser au contenu de la branche de ressources (hormis le cas spécial des polices de caractères et des programmes/applications).

Branche de ressources
La branche de ressources contient le code des programmes, les polices, etc. Elle peut également, dans le cas d'un fichier graphique, contenir une image (vignette) de prévisualisation.
Contrairement à ce qui est parfois dit (y compris par des personnes généralement compétentes et bien informées par ailleurs), la branche de ressources ne contient pas la signature des fichiers (le type de fichier et le créateur du fichier). Ce n'est donc pas parce qu'un fichier Macintosh est passé sur un PC et a donc (généralement) perdu sa branche de ressources qu'il devient illisible et inexploitable. L'absence de signature correcte empêche uniquement d'ouvrir le fichier par un double clic sur son icône. Tant que le contenu utile est stocké dans la branche de données, rien n'est perdu. Il suffit généralement d'ouvrir le fichier en passant par l'application voulue (menu Fichier, rubrique Ouvrir).

Pourquoi une branche de ressources ?
La branche de ressources est organisée comme une base de données et non pas sous la forme d'un flux non structuré d'octets, comme c'est le cas de la branche de données. Cela permet un accès très rapide aux éléments qui y sont stockés, et même une mise à jour lorsque des éléments doivent être modifiés.

Comment ne pas dissocier les deux branches ?
La « perte » de la branche de ressources est l'une des catastrophes mythiques qui revient sans cesse dans les discussions sur les transferts de fichiers Macintosh.
Deux méthodes sont utilisées essentiellement pour conserver ensemble les deux branches des fichiers Macintosh. Il s'agit de la norme MacBinary et de la norme BinHex.
Apple a également publié deux normes, appelées Apple Single et Apple Double, pour pallier ce problème.


Format Binhex

Introduction
Le format BinHex a été inventé pour répondre à deux besoins. D'une part celui de coder sur 7 bits seulement le contenu des fichiers binaires (donc codés sur 8 bits), afin de leur permettre de transiter par les réseaux, et par le courrier électronique, notamment. D'autre part celui de réunir les deux branches des fichiers Macintosh en un seul fichier.
Enfin, l'auteur de cette norme, Yves Lempereur, a rajouté une fonction de compression élémentaire, de type RLE, pour éviter de transmettre des séquences de plusieurs caractères identiques.

Comment reconnaître un fichier codé en BinHex ?
L'extension utilisée pour les fichiers BinHex est généralement HQX, mais on rencontre aussi fréquemment des fichiers sans extension. La signature de ces fichiers (sur un support HFS) est TEXTBNHQ.
De plus, la première ligne des fichiers codés en BinHex est la suivante :

(This file must be converted with BinHex 4.0)

Il suffit donc d'ouvrir le fichier dans un programme de traitement de textes pour l'identifier. Cette ligne est normalement facultative, mais nous n'avons jamais rencontré de fichiers BinHex qui ne la comportent pas. L'une des caractéristiques de ces fichiers est également que le flux de données utile doit commencer et finir par le signe "guillemets".
Nous avons déjà vu des fichiers où la ligne ci-dessus n'était pas la première, mais la seconde. Dans ce cas, nos programmes n'identifient pas correctement les fichiers comme des fichiers BinHex et les traitent comme des fichiers de données. Ouvrez le fichier dans un éditeur de texte et supprimez la première ligne.

Quand peut-on rencontrer des fichiers BinHex ?
La norme BinHex est l'une des options (avec le format mime) de la plupart des logiciels de messagerie Macintosh. Ces programmes codent et décodent le format de manière transparente pour l'utilisateur. Toutefois, lorsque le courrier est échangé entre Mac et PC, il est possible que le logiciel de réception ne sache pas identifier ces fichiers et se contente de les stocker sur le disque dur.
Le format BinHex est également utilisé par certains programmes pour générer des fichiers Macintosh sur d'autres plates-formes. C'est notamment le cas de Flash, de Macromedia. Dans ce cas, la norme BinHex joue le même rôle que la norme MacBinary, le codage sur 7 bits n'ayant pas de justification technique.

Comment décoder les fichiers BinHex ?
Il existe un certain nombre d'utilitaires assurant le décodage des fichiers BinHex sur un PC. Ils ne se caractérisent généralement pas par leur souplesse ou par leur généralité. Les problèmes de fonctionnement que l'on peut rencontrer sont les suivants :

  • Pas de récupération du véritable nom du fichier
  • Pas d'ajout d'extension pour identifier la nature du fichier
  • Pas de récupération du contenu de la branche de ressources.

Par opposition, tous nos programmes connaissent le format BinHex et traitent ces fichiers correctement.


Format MacBinary

Fichiers MacBinary
La norme de fait MacBinary (les spécifications des versions I, II et III sont disponibles sur le site de Lazerware mais n'intéresseront que les programmeurs) a pour raison d'être de maintenir dans un conteneur unique les deux branches du fichier Macintosh, afin qu'elles ne soient pas dissociées et perdues sur les liaisons de télécommunications ainsi que dans les répertoires des serveurs. De même que les archives SEA, qui ne constituent qu'un cas particulier des fichiers MacBinary, ils se présentent sous la forme d'un conteneur composé de trois parties :

  • En-tête du Finder (longueur 128 octets)
  • Branche de données (longueur variable)
  • Branche de ressources (longueur variable, commençant sur une frontière de bloc de 128 octets).

Il arrive que l'on ait à télécharger depuis un serveur Internet ou autre des fichiers Macintosh, qu'il s'agisse de données, de programmes ou d'archives autoextractibles. Généralement, les fichiers à télécharger sont stockés sous la forme d'un conteneur MacBinary (voir également notre page sur le format BinHex). Certaines précautions doivent être prises pour replacer correctement les éléments du fichier si l'on souhaite pouvoir les exploiter sur le Macintosh.

Réinstallation d'un fichier MacBinary sur un support Mac
Il est relativement simple de réinstaller un fichier MacBinary sur un support Macintosh, pour pouvoir ensuite l'exécuter sur un Macintosh, qu'il s'agisse d'un programme en général ou d'une archive autodécompactable.
Nous allons décrire la procédure avec MacDisk et une disquette.
Prenez une disquette Macintosh ou formattez-en une (n'oubliez pas que vous pouvez effectuer un reformatage rapide sur une disquette PC 1,44 Mo en bon état). Cliquez sur le bouton de copie entre le PC et le Mac. Sélectionnez le fichier dans la boîte de dialogue et lancez la copie. MacDisk détecte automatiquement les fichiers MacBinary et BinHex.
Vous observerez que le fichier, sur le support Macintosh, ne porte pas nécessairement le nom qu'il avait sur le support PC. En effet, le nom Macintosh original du fichier était stocké dans l'en-tête binaire et notre programme l'a restauré. Vous observerez aussi qu'une partie du fichier a été placée dans la branche de données et une autre dans la branche des ressources.
Il vous suffit maintenant de monter le volume sur un Macintosh. S'il s'agit d'une application, double-cliquez sur l'icône pour l'exécuter.

Installer un fichier MacBinary dans un projet sous MacImage
Quand vous incluez dans un projet un fichier MacBinary, MacImage l'identifie automatiquement et va chercher à l'intérieur du fichier les renseignements dont il a besoin. Vous n'avez rien de spécial à faire, tout s'opère automatiquement.


Icônes personnalisées

Introduction
Le Macintosh permet depuis très longtemps d'attribuer aux fichiers, aux dossiers et aux volumes (disques) des icônes personnalisées, qui remplacent l'icône par défaut qui serait sinon affichée par le Finder (icône fournie par le système d'exploitation ou encore par l'application utilisée pour créer/éditer le fichier).
Dans le cas d'un fichier, il peut s'agir d'une icône spécifiant le contenu, ou d'une image de prévisualisation d'un fichier graphique.
Dans le cas d'un dossier (ou d'un volume, qui n'est qu'un cas particulier puisqu'il s'agit en fait de la racine), l'icône est sensée représenter les fichiers contenus, ou symboliser le producteur des données.

Comment faire sur le Macintosh ?
La méthode classique, sur le Macintosh, consiste à afficher les informations sur le dossier ou sur le fichier et à coller dans l'icône affichée des données copiées depuis une application graphique.

Comment faire avec MacImage ?
MacImage est fourni avec un module spécialisé appelé WinComposer. Ce module vous permet d'importer de nombreuses ressources graphiques (icônes Windows, icônes Macintosh, nombreux formats graphiques) et de produire des icônes de 16*16, 32*32, 48*48 et 128*128 pixels.
Dans le cas d'un dossier normal, l'icône multiformat ainsi produite (sauvegardée sous la forme d'une branche de ressources stockée dans un conteneur MacBinary) est placée dans le dossier voulu (MacImage déballe automatiquement le conteneur) et la case « Icône personnalisée » est cochée dans la rubrique du dossier.
Dans le cas du volume, la même procédure s'applique pour Mac OS 9 et inférieur, le fichier étant placé dans la racine du disque. Dans le cas de Mac OS X, il faut également y placer un fichier appelé '.VolumeIcon.icns' contenant une icône dans la branche de données.
Ces fichiers doivent être cachés. Dans le cas du conteneur MacBinary, WinComposer place lui-même l'attribut voulu dans l'en-tête MacBinary. Dans le cas du fichier '.VolumeIcon.icns', il faut que vous le fassiez vous-même dans la boîte Propriétés.
La fonction n'existe pas encore dans le cas des fichiers.

Aspects techniques
Le principe technique est relativement simple. Ces icônes personnalisées sont des icônes normales (voir l'aide de WinComposer pour des informations plus techniques), mais qui doivent porter le numéro d'identification « magique » -16455). Le fichier qui les contient doit être caché. Un drapeau d'attribut spécial doit être armé dans la rubrique du dossier dans le catalogue.
Dans le cas d'un fichier, les données graphiques (qui doivent répondre aux mêmes conditions) sont intégrées dans la branche de ressources du fichier. Cette fois, c'est la rubrique du fichier elle-même dont l'attribut doit être correctement armé.
Ces ressources graphiques ne sont pas enregistrées par le Finder dans sa base de données (Desktop).

Icônes personnalisées de dossiers
Le dossier doit contenir un fichier caché appelé 'Icon\r' (avec 0x0D comme dernier caractère) contenant des ressources graphiques voulues de type icône (voir les explications détaillées données dans l'aide de WinComposer). L'atttibut « Icône personnalisée » doit être armé dans la rubrique du dossier.

Icônes personnalisées de volumes
Sous Mac OS 9 et antérieur, la racine du disque est traitée comme un dossier normal et doit contenir le même fichier 'icon\r'.
Sous Mac OS X, le fichier contenant l'icône doit être nommé '.VolumeIcon.icns', il doit être caché et l'icône, contenue dans la branche de données, doit être de type 'icns' (voir l'aide de WinComposer pour des informations techniques complémentaires).
Si vous visez toutes les versions du système d'exploitation Macintosh, vous pouvez inclure les deux fichiers. Mac OS X a repris de ses racines Unix la convention de traiter tous les fichiers commençant par un point comme des fichiers systèmes cachés. Le fichier '.VolumeIcon.icns' ne sera donc jamais affiché sous Mac OS X. Ce n'est pas le cas sous Mac OS 9 et antérieur, qui ne connaît pas cette convention. Il est donc indispensable d'armer l'attribut caché de ce fichier si vous ne voulez pas semer la perplexité parmi les utilisateurs.


Signatures Macintosh

Qu'est-ce que la signature d'un fichier Macintosh ?
Pour identifier le type de fichier, le Macintosh n'utilise pas une extension de trois caractères (ou même de quatre, ou plus encore), mais une signature. Les signatures sont des chaînes de huit caractères, à savoir quatre pour le créateur (le programme qui a créé le fichier) et quatre pour le type de fichier (texte, image, etc.).
La table de ces signatures et les icônes correspondantes sont stockées par le Finder, pour toutes les applications qui ont existé à un moment quelconque sur un disque, dans le fichier Desktop (un fichier système qui n'est jamais affiché par le Macintosh mais qui existe dans la racine de chaque disque). Avec le Système 7, le Desktop s'est dédoublé en un fichier appelé Desktop DB et un autre appelé Desktop DF, pour des raisons qu'il serait trop long d'expliciter ici.

Où sont stockées les signatures ?
Contrairement à ce qui est souvent affirmé, même par des personnes qui savent généralement ce dont elles parlent, ces signatures ne sont pas stockées dans la branche des ressources de chacun des fichiers, mais gérées par le Finder dans l'arbre du catalogue (une structure de gestion du disque à laquelle l'utilisateur n'a pas besoin d'avoir accès directement).
Cette erreur a une triple explication. D'une part, dans le fait que les programmes doivent déclarer (dans leur branche de ressources) le type de fichier qu'ils entendent gérer, de manière à ce que le Finder sache quoi faire lorsque l'utilisateur effectue un double clic sur une icône.
De même, l'icône affichée pour un fichier donné est trouvée par le Finder dans la branche de ressources du programme et est ensuite stockée dans le fichier Desktop. Enfin, certains programmes créant des fichiers graphiques placent dans la branche de ressources du fichier de données une image en basse résolution (image de prévisualisation) qui est utilisée par le Finder à la place de l'icône générique.

Tables de signatures
Nous avons regroupé ci-dessous certaines signatures et les extensions de type PC qui leur correspondent (si vous souhaitez ajouter ou corriger quelque chose, vous pouvez naturellement nous le faire savoir. Cette page est mise à jour pratiquement une fois par semaine.
Pour ceux qui sont amenés à éditer la table des signatures utilisée par nos programmes MacDisk et MacImage), vous devez noter la signature et l'extension que vous entendez utiliser et l'intégrer dans le fichier de signatures avec l'utilitaire SignEdit ou encore un éditeur de texte. De même, si un transfert ne donne pas les résultats que vous attendez, contrôlez la signature réelle d'un fichier dont l'origine est certaine, sur un véritable support Macintosh (regardez dans la dernière colonne du volet d'affichage, ou encore dans la boîte de dialogue 'Propriétés').

Formats "génériques"
Ces signatures identifient un type de fichier, mais sans spécifier le créateur ('????' est une chaîne de créateur valide). Elles sont souvent utiles lorsqu'un programme n'accepte d'importer qu'un type spécifique de données, sans se donner la peine d'aller ouvrir le fichier pour savoir ce qu'il contient réellement. Nous indiquons l'extension PC lorsque celle-ci est bien établie.

Signature | Extension | Commentaires
APPL???? |  | Application (programme)
EPSF???? | EPS | EPS générique
JPEG???? | JPG | JPEG générique
PICT???? | PCT | Fichier Pict générique
TEXT???? | TXT | Texte générique
TIFF???? | TIF | TIFF générique

Formats "spécifiques"
Ces signatures identifient d'une part le type de fichier, d'autre part le créateur. Les applications autres que le créateur se contentent généralement de consulter le type de fichier pour déterminer si elles sont en mesure de le traiter.

Signature | Extension | Commentaires
8BIM8BIM | PSD | Photoshop 3
8BIM8BPS | PSD | Photoshop 3 (calques)
AB65AD65 | P65 | Pagemaker 6.5
ALB4ALD4 | PM4 | Pagemaker 4
ALB5ALD5 | PM5 | Pagemaker 5
ALB6ALD6 | PM6 | Pagemaker 6
APPLaust |  | Archive autodécompactable créée par Stuffit
APPLEXTR |  | Archive autodécompactable créée par Compact Pro
cDRWdDRW |  | Claris Draw
CWWPBOBO | CWK | Claris Works v. 1 à 5
dPROdDOC | MDP | MacDraw Pro
DDAPDDFL |  | Fichier compressé par Disk Doubler ??
EPSPXPR3 |  | EPS Spécial Xpress
FH50AGD1 | FH5 | Freehand 5
FHD3FHA3 | FH3 | Freehand 3
FMP3FMP3 | FP3/FMP | FileMaker Pro
FXTCEggP | AEP | Projet d'After Effects
inDdinDn | IND | Document Indesign
LWFNASPF |  | Police Type 1 d'Adobe
MDPLDRWG |  | Fichiers MacDraw II
MDRWDRWG |  | Fichiers MacDraw
MooVTVOD | MOV | Fichiers QuickTime
MV93MD93 | DIR | Macromedia Director
MW2DMWII |  | Mac Write II
nX^2nX^n |  | WriteNow 3
nX^nnX^n |  | WriteNow 2
PACTCPCT |  | Archive créée par Compactor (Pro)
PDF CARO | PDF | Fichiers Acrobat (notez l'espace après PDF)
QSfLQSfl |  | Fichier de contrôle de l'AV Symantec
SIT!SIT! | SIT | Archive compactée par Stuffit
SITDSIT! | SIT | Archive compactée par Stuffit
SLD3PPT3 | PPT | Power Point 3
SLD8PPT3 | PPT | Power Point 98
StMIGIFf | GIF | Fichiers GIF créés par PageMill
StMITEXT | HTM | Fichiers HTML créés par PageMill
TEXTART3 | AI | Illustrator 3
TEXTBNHQ | HQX | BinHex
TEXTOMEG |  | Mathematica (tous types de fichiers)
W6BNMSWD | DOC | Microsoft Word 6
W8BNMSWD | DOC | Microsoft Word 8 (98)
WDBNMSWD | DOC | Word 3/4/5 Macintosh
WORDBOBO | CWK | Claris Works (texte)
WORDMACA |  | Mac Write 4.6/5
WP42SSIW | WP4 | Wordperfect 4 (sauvé par WP Mac)
WP50SSIW | WP5 | Wordperfect 5 (idem)
WTBNMSWD | DOT | Modèle Word
XDOCXPR3 | QXD | Xpress (toutes versions)
XLBNXCEL | XLS | Excel 1 pour le Macintosh
XLS4XCEL | XLS | Excel 4
XLS5XCEL | XLS | Excel 5
ZIP_ZIP_ | ZIP | Archive de type Zip (le '_' est un espace)

Nous reprenons ci-dessous une liste plus complète avec d'abord une liste des types de fichiers que nous avons déjà rencontrés, puis une liste des créateurs que nous avons identifiés.

Types de fichiers
Signature | Commentaires
..CT | Fichier Scitex (placez 8BIM dans le créateur si vous voulez que ces fichiers s'ouvrent directement dans Photoshop
.WP4 | Texte WP 4 vu par Wordperfect 2
.WP5 | Texte WP 51 vu par Wordperfect 2
8BIM | Fichier Adobe Photoshop au format natif
8BPS | Calque Photoshop
AB65 | Pagemaker 6.5
ALB3 | PageMaker 3
ALB4 | PageMaker 4
ALB5 | PageMaker 5
ALB6 | PageMaker 6
AWDB | Base de données MS-Works
AWSS | Feuille de calcul MS-Works
AWWP | Traitement de textes MS-Works
BINA | Fichier de texte sauvé au format DOS ou Winword par Word Mac 5
CrTC | Fichier de projet de Toast 3
CWWP | Fichier de texte de Claris Works
DCT5 | Dictionnaire de Word
DDFL | Fichier de données de Disk Doubler
dDOC | Fichier de dessin de MacDraw Pro
dDRW | Fichier de dessin Claris Draw
DRWG | Fichier de dessin de MacDraw
DWG_ | Fichier AutoCAD ?? (avec un espace final)
EggP | Projet d'After Effects
EPSF | Fichier EPS
FFIL | Valise de polices (Type 1 ou True Type)
ffil | Police d'affichage
FH50 | Fichier Freehand 5
FHD3 | Fichier Freehand 3
F#+D | Fichier de Rag Time Classic
FMK$ | Fichier de FileMaker
FMP3 | Fichier de FileMaker Pro 3
GIFf | Fichiers GIF de PageMill
GLOS | Glossaire de Word
Himg | Fichier-image créé par Toast
inDd | Document Indesign
JPEG | Fichier JPEG
lfil | Police True Type
LWFN | Police type 1 (PostScript)
MooV | Fichier QuickTime
MPEG | Fichier MPEG (codage MPEG1)
MPWd | Document MacWrite Pro 1.5
MW2D | Document MacWrite II
MW2S | Document MacWrite II (modèle)
nX^2 | Fichier Write Now 3
nX^d | Fichier Write Now 2
PACT | Fichiers Compactor
PDF_ | Fichiers Acrobat (PDF). Le _ représente un espace)
PICT | Fichier graphique
R#+A | Fichier de texte de RagTime Classic
RTF_ | Fichier RTF (le _ étant un espace)
S#+A | Fichier de texte de Rag Time 2
SIT! | Archive Stuffit
SITD | Archive Stuffit
SLD3 | PowerPoint 3
SLD8 | PowerPoint 8
TIFF | Format graphique
W6BN | Mac Word 6
W8BN | Mac Word 8 (98)
WDBN | Mac Word 3, 4, 5
WHLP | Fichier d'aide de Word
WORD | MacWrite (texte formaté)
WP42 | Texte WP 4 vu par Wordperfect 1
WP50 | Texte WP 51 vu par Wordperfect 1
WPD0 | Texte Wordperfect 1
WPD1 | Texte Wordperfect 2
WPD3 | Texte Wordperfect 3
WPRD | Fichier d'impression de Word
WTBN | Modèle Word
XDOC | Fichier Xpress
XTMP | Gabarit Xpress
XLBN | Feuille de calcul Excel 1
XLS_ | Feuille de calcul Excel 2.2 (le _ représente un espace)
XLS3 | Feuille de calcul Excel 3
XLS4 | Feuille de calcul Excel 4
ZIP_ | Archive zippée (le _ représente un espace)

Codes des créateurs
Signature | Commentaires
8BIM | Adobe Photoshop
AD65 | Pagemaker 6.5
ACAD | AutoCAD
AGD1 | Freehand 5
ALD3 | PageMaker 3
ALD4 | PageMaker 4
ALD5 | PageMaker 5
ALD6 | PageMaker 6
ART3 | Illustrator 3
ART5 | Illustrator 5 et suivants
ARTY | Illustrator 1
ARTZ | Illustrator 88
BOBO | Claris Works
CARO | Acrobat Distiller
CDr3 | Toast v. 3
cDRW | Claris Draw
CPCT | Compactor (Pro ?)
DDAP | Application Disk Doubler
dPRO | MacDraw Pro
ERIK | Finder (fichier Desktop)
F#+A | Rag Time Classic
FHA3 | Freehand 3
FMK4 | FileMaker (II ?)
FMP3 | FileMaker Pro 3
FXTC | After Effects
inDn | Indesign
MACA | MacWrite 2.2 et 4.6
mdos | Fichier DOS copié par AFE ou Echange PC-Mac
MDRW | MacDraw
MDPL | MacDraw II
MOSS | Netscape (Mozilla)
MPWR | MacWrite Pro
MSWD | Microsoft Word 3/4/5 pour le Mac
MSWK | Microsoft Works 3/4 pour le Mac
MWII | MacWrite II
nX^n | Write Now toutes versions
OMEG | Mathematica
PPT3 | PowerPoint (toutes versions)
PSIP | MS-Works 1
PSI2 | MS-Works 2
R#+D | Rag Time 3
S#+D | Rag Time 2
SIT! | Stuffit
SSIW | Wordperfect 1
StMI | PageMill
TVOD | QuickTime
vgrd | LaserWriter (fichier Postscript)
WPC2 | Wordperfect 2 (3 aussi)
XPR3 | QuarkXpress 3
XCEL | Excel

Quelques sites complémentaires pouvant vous aider dans votre recherche :

  • Page des signatures de notre site Internet
    Étant donné que la présente page n'est qu'une copie de la page que nous consacrons à cette question sur l'Internet, vous pouvez éventuellement la visiter pour disposer des dernières mises à jour.
  • Site d'enregistrement Apple
    Les signatures [ou du moins les chaînes de créateur] doivent être enregistrées auprès d'Apple. Ce site permet de savoir si une signature existe ou non. Il n'y a pas de possibilité de consultation d'une liste générale, et Apple a déclaré publiquement qu'il n'y en aurait pas.
  • Index d'Ilan Szekely
    Un index à télécharger (Filemaker Pro pour le Mac) contenant plus de 30 000 références de signatures.


Fichiers Macintosh sur l'Internet

Internet et les fichiers Macintosh
La réception de fichiers Macintosh sur un PC depuis l'Internet (téléchargement depuis un serveur FTP ou HTTP, réception en tant que pièce jointe annexée à un courrier électronique) mérite quelques commentaires pour deux raisons.
D'abord, les fichiers Macintosh ne sont pas monolithiques, mais se composent de deux parties, la première appelée "branche de données" (data fork) et la seconde "branche de ressources" (resource fork). Voyez la page que nous consacrons à cette question des branches des fichiers pour plus de précisions.
Ensuite, la nature des fichiers n'est pas exprimée sous la forme d'une extension ajoutée au nom du fichier (suffixe), mais sous la forme d'une signature (chaîne de 8 caractères exprimant le créateur du fichier et le type du fichier). Voir également la page que nous consacrons aux signatures Macintosh pour plus de précisions.

"Conteneurisation"
Pour ces deux raisons, les fichiers Macintosh stockés sur des serveurs gérés sous des systèmes d'exploitation qui ne connaissent pas les branches ou flux doivent être "conteneurisés" afin de sauvegarder leurs éléments constitutifs. Les logiciels Macintosh effectuent le plus souvent ce type de traitement sans le signaler spécifiquement
Ajoutons enfin que les normes du courrier électronique imposent de ne transmettre que des fichiers de texte, et non pas des fichiers binaires. Cela revient à dire que les fichiers doivent être codés sur 7 bits et non pas sur 8 bits. Cette opération s'effectue le plus souvent sur le conteneur mentionné ci-dessus.

Les fichiers Macintosh envoyés en pièces jointes
Dans ces conditions, et pour que les utisisateurs Macintosh ne perdent aucun élément de leurs fichiers lorsque ceux-ci sont envoyés par le courrier électronique, l'usage est que les logiciels de courrier électronique tournant sur un Macintosh effectuent deux opérations sur les fichiers émis :

  • conteneurisation (regroupement des deux branches ainsi que des informations du Finder dans un conteneur, donc un fichier unique)
  • encodage (passage de 8 bits à 7 bits)
Par opposition, un logiciel de courrier sur un PC n'exécute que l'encodage.
A la réception, le programme doit d'abord décoder le flux de données, puis ouvrir le conteneur pour en récupérer les éléments.

Normes utilisées
Quatre normes sont utilisées pour effectuer ces opérations. D'abord, MacBinary et AppleSingle, qui prennent en charge la conteneurisation. Le principe de base est de mettre les deux branches l'une derrière l'autre et d'y ajouter des éléments tels que la signature. Le fichier obtenu est ensuite codé sur 7 bits. Dans le premier cas, les données précèdent les ressources, dans le second cas, c'est le contraire.
La norme AppleDouble, qui est comme AppleSingle une norme MIME (RFC1740), utilise une méthode radicalement différente, en plaçant les deux branches dans des flux différents qui peuvent être intégrés dans le message électronique par le logiciel de courrier. A la réception, le client décode ce qu'il reconnaît, généralement la seule branche de données, la branche de ressources étant alors ignorée et donc perdue.
Enfin, le cas du format Binhex est un peu spécial en ce sens que les deux opérations sont effectuées en même temps et que le fichier obtenu est un conteneur codé sur 7 bits et comprimé, donc prêt à envoyer. Si la phase d'encodage n'est pas strictement nécessaire dans le cas d'un téléchargement sur un serveur HTTP ou FTP, l'ancienneté de cette norme fait qu'elle est fréquemment utilisée aussi pour ce type d'opérations.

Traitement des fichiers
La difficulté essentielle est d'identifier les traitements qui ont été exécutés sur le ou les fichiers que vous recevez.
Notre utilitaire MacMail permet d'automatiser dans une large mesure le traitement des pièces jointes. Nous vous invitons à consulter sa page pour en savoir plus.
Il reste toujours possible d'ouvrir le fichier dans un traitement de textes et de rechercher au début des éléments caractéristiques.
Les fichiers Binhex contiennent la chaîne suivante dans la première ligne : "(This file must be converted with BinHex 4.0)".
Les fichiers MacBinary peuvent se reconnaître au fait qu'ils contiennent au tout début (décalage 2) une chaîne de caractères qui est le nom Macintosh original du fichier, puis un peu plus loin (décalage 65) la signature du fichier original.
Les fichiers AppleDouble et AppleSingle ne devraient normalement pas se rencontrer tels que sur votre ordinateur. Ces formats sont utilisés dans le courrier électronique avec des programmes modernes, qui devraient les décoder automatiquement. Néanmoins, précisons que la "signature magique" des fichiers AppleSingle est 0x00051600 tandis qu'elle est de 0x00051607 pour les fichiers AppleDouble. Cette signature se trouve dans les quatre premiers octets du fichier unique dans le cas de la norme AppleSingle et dans les quatre premier octets du fichier d'en-tête (qui contient tous les éléments du fichier hormis la branche de données) dans le cas de la norme AppleDouble.

Cas spécial des polices de caractères
Si vous recevez des polices de caractères Macintosh par courrier électronique et que votre interlocuteur les a codées en AppleDouble ou en AppleSingle, vous ne pouvez rien faire, sinon constater que le fichier obtenu est de longueur nulle. Les logiciels clients de courrier qui savent en effet traiter ces formats adoptent l'attitude la plus logique, qui est de récupérer ce qui est probablement récupérable, donc la branche de données.
Même si ce n'est pas du tout ce que vous vouliez faire.

Pour pouvoir récupérer la police et l'utiliser, il faut employer un logiciel connaissant la nature des deux autres modes de codage, à savoir BinHex et MacBinary.
Notez tout de même que si l'on vous a envoyé une police d'affichage, elle ne peut servir à rien. Seules les polices True Type et les polices Type 1 contiennent du code exploitable.
Voyez également la page plus générale que nous consacrons aux Transferts de polices.

Comment expédier un fichier vers un Macintosh
Le problème ne se pose pas seulement d'exploiter sur PC des fichiers créés sur un Macintosh et envoyés par courrier électronique. Il existe de la même manière si vous voulez envoyer un fichier en pièce jointe depuis votre PC. Plusieurs solutions sont possibles, en fonction du degré de connaissances de votre interlocuteur.
Si vous envoyez un fichier de bureautique, par exemple Word ou Excel, veillez bien à ne pas envoyer un fichier codé dans une version trop récente du programme. Nous conseillons, pour les fichiers Word, de sauvegarder au format Word 5 pour le Macintosh, ou encore au format Word 2 pour Windows, et pour les fichiers Excel, d'enregistrer au format Excel 5.
Un fichier PC simplement envoyé de cette manière en pièce jointe n'aura probablement pas de signature en arrivant sur le Macintosh. Cela signifie que l'utilisateur ne devra pas essayer de l'ouvrir en cliquant deux fois sur son icône, mais en passant par le programme voulu et par le menu Fichier, puis Ouvrir.


Icônes Macintosh

Introduction
Cette page est de nature relativement technique. Dans la mesure où j'ai rencontré de sérieuses difficultés à recueillir les informations nécessaires, sur le site d'Apple ainsi que d'autres, j'ai décidé de publier ici les données avérées que j'ai pu noter au fur et à mesure.

Table des différentes ressources utilisées pour les icônes

Signature | Commentaires
cicn | Icônes des menus et des dialogues, couleur (cicn = color icon), contenant une palette, un bitmap et un masque. C'est soit une icône 32*32 avec masque, soit une icône de taille quelconque sans masque. Il est possible de définir la profondeur de couleurs. Voir IM:Imaging with QuickDraw.
clut | Table de consultation (Color Look-Up Table). Ressource contenant la table de consultation (palette) utilisée par le Palette Manager. Les principales palettes par défaut sont la palette N&B, la palette 16 couleurs, la palette des icônes et la palette 256 couleurs. Voir les palettes affichées par WinComposer sur son onglet Palettes.
h8mk | Masque 32*32, 256 niveaux de transparence, longueur 2304 (0x900).
ich# | Icône 48*48, N&B + masque, longueur 576 octets (0x240)
ich4 | Icône 48*48, 16 couleurs, taille 1152 octets (0x480)
ich8 | Icône 48*48, 256 couleurs, taille 2304 octets (0x900)
icl4 | Icône 32*32, 16 couleurs (4 bits), taille 512 octets (0x200)
icl8 | Icône 32*32, 256 couleurs (8 bits), taille 1024 octets (0x400)
icm# | Mini-icônes (12*16), N&B
icm4 | Mini-icônes (12*16), couleur, 4 bits
icm8 | Mini-icônes (12*16), couleur, 8 bits
ICN# | Icône 32*32 N&B (1 bit/pixel) + le masque, taille 256 octets (2 * 128).
icns | Resource unique contenant plusieurs ressources d'icônes dans un conteneur unique. Sous Mac OS X, il est possible de fournir les icônes dans un fichier dont l'extension doit être *.icns.
Icon | Icônes des menus
ICON | Icônes des menus et des dialogues, 32*32, N&B, sans masque. Toujours affiché sur fond blanc, donc pas de masque.
ics# | Icône 16*16, N&B, longueur 64 octets
ics4 | Icône 16*16, 16 couleurs, taille 128 octets
ics8 | Icône 16*16, 256 couleurs, taille 256 octets
ih32 | Icône 48*48, 32 bits, longueur variable (ressource comprimée).
il32 | Icône 32*32, 32 bits, longueur variable (ressource comprimée).
is32 | Icône 16*16, 32 bits, longueur variable (ressource comprimée).
it32 | Icône 128*128, 32 bits, longueur variable (ressource comprimée).
l8mk | Masque 32*32, 256 niveaux de transparence, taille 1024 octets
s8mk | Masque 16*16, 256 niveaux de transparence, taille 256 octets
SICN | Icônes système (S) ou aussi small (?). Format 12*16, stockées dans une matrice 16*16. Le format permet de stocker un nombre quelconque d'icônes,mais par convention, il y a seulement une icône N&B et son masque.
t8mk | Masque 128*128, 256 niveaux de transparence, longueur 0x00004008 (longueur utile 16384)

La ressource icns pour les icônes modernes
La plupart des ressources ci-dessus revêtent un aspect assez historique. La tendance actuelle est à l'emploi pratiquement exclusif de la ressource icns, dont le gros avantage est d'éviter l'éparpillement, puisque toutes les ressources nécessaires sont incluses dans un conteneur unique.
Cette ressource, dont on notera qu'elle n'est pas comprise par l'utilitaire ResEdit, a été introduite avec le Système 8.5.
À titre de précaution, il convient donc toujours de lui ajouter une ressource d'icône monochrome de base, de type ICN#, pour le cas (peu probable aujourd'hui) où la machine de destination tournerait sous une version plus ancienne du système.
De la même manière, compte tenu du renouvellement du parc, il est peu probable qu'il soit nécessaire de fournir des icônes en 4 bits/pixel.
Une ressource icns moderne contiendra donc une ressource ICN# et les ressources 32 bits pour les icônes en 32*32 pixels, 48*48 pixels et éventuellement 128*128 pixels.

Méthode de compression
Les icônes en 32 bits/pixel peuvent être comprimées. À la lecture, il convient donc de vérifier que la longueur annoncée dans l'en-tête de la ressource ne correspond pas à sa taille théorique (largeur * hauteur).
Si tel est le cas, il convient de décomprimer les données. Le principe est d'avoir une compression canal par canal, dans l'ordre rouge, vert puis bleu. Le canal alpha n'est pas inclus dans cette ressource comprimée. Il faut aller le chercher dans la ressource ?8mk correspondant (voir le tableau ci-dessus).

Pseudo-code :
La méthode de compression utilisée n'a pas été documentée par Apple. Elle a cependant été élucidée, probablement par Peter Stuer (Peter.Stuer@pandora.be). J'ai utilisé comme base de travail le code de ResCafé, un utilitaire d'exploration des ressources Macintosh écrit en Java par G. Brannon Smith.
Pour chacune des couleurs (rouge, vert, bleu) et sur la longueur maximale qui correspond à la taille de l'image, lire un octet.
Si le bit 8 de l'octet est armé :
   C'est une séquence comprimée d'une valeur unique (qui suit immédiatement).
   La longueur est égale à l'octet - 125.
   Placer le tout dans le canal de la couleur en cours.
Sinon :
   C'est une séquence non comprimée, dont les valeurs suivent.
   La longueur est de octet + 1.
   Lire et les placer dans le canal de la couleur en cours.


Enregistrement groupé

Introduction
Dans son menu Fichier, WinComposer vous propose une fonction de sauvegarde de l'ensemble des icônes affichées sur l'onglet Assembleur d'icônes.

Formats proposés
WinComposer propose les formats d'enregistrement suivants :

  • Icônes Macintosh (données),
  • Icônes Macintosh (ressources),
  • Icônes Macintosh (les deux branches),
  • Icônes Windows,

Pourquoi trois formats Macintosh ?
Traditionnellement, les icônes sont stockées dans la branche de ressources. Cependant, Mac OS X peut également utiliser les icônes, et d'une manière générale toutes les ressources, qui sont stockées dans la branche de données.
Certains utilitaires employés dans la production des icônes sauvent même parfois leurs fichiers en mettant les données graphiques deux fois, une fois dans la branche de données et une fois dans la branche de ressources.
Il convient donc de choisir le format de sauvegarde en fonction de l'utilisation que vous en prévoyez. Voyez en particulier la page que nous consacrons aux icônes personnalisées.

Icônes Macintosh (données)
Ce type d'icônes ne peut être exploité que sous Mac OS X. Notez bien cependant qu'il n'y a pas de différence de nature dans les données graphiques et leur organisation dans le fichier, c'est-à-dire que le contenu de la branche de données, placé dans une branche de ressources, serait parfaitement reconnu par ResEdit ou d'autres éditeurs de ressources.
Si le fichier est destiné à être utilisé comme icône personnalisée de volume sous Mac OS X, vous devez utiliser le nom '.VolumeIcon.icns'. Notez bien le point au début du nom.
Retour en haut de la page

Icônes Macintosh (ressources)
C'est la méthode traditionnelle de stockage des icônes. WinComposer sauve les icônes dans une branche de ressources stockée dans un conteneur MacBinary. Le nom utilisé à l'intérieur de l'en-tête MacBinary est 'icon\r'.
Ce fichier est destiné à servir d'icône personnalisée pour un dossier (toutes versions de Mac OS) ou pour un volume (Mac OS 9 et inférieur).
Retour en haut de la page

Icônes Macintosh (les deux branches)
Il peut parfois être utile de réunir les deux solutions ci-dessus dans un seul fichier (donc, une branche de données et une branche de ressources sauvées dans un conteneur MacxBinary).
Retour en haut de la page

Icônes Windows
Les fichiers d'icônes Windows contiennent le plus souvent une seule icône, dans un seul format et dans une seule profondeur de couleur. Cependant, la spécification du format des fichiers *.ICO permet d'y stocker plusieurs formats et plusieurs profondeurs de couleurs.
Pour comprendre l'intérêt de ces fichiers, placez le fichier sauvé par WinComposer dans un dossier et changez le mode d'affichage de l'Explorateur (Miniatures, Mosaïque, Icônes, Liste, Détails). Vous constaterez que Windows, en changeant de mode d'affichage, sélectionne dans le fichier le format d'icône qui convient le mieux. Le résultat est optimal.
À l'inverse, faites la même opération avec un fichier d'icône individuel (sauvegardé à partir du menu contextuel. L'affichage est bon dans un des modes de visualisation, mais Windows est obligé de calculer lui-même la réduction et l'agrandissement dans les autres cas, et le résultat est beaucoup moins bon.
Retour en haut de la page

Voir aussi la page consacrée à l'Enregistrement individuel des icônes.


Enregistrement individuel

Introduction
En dehors de son menu Fichier qui offre classiquement une fonction d'enregistrement des icônes sous la forme de fichiers collectifs (fichiers regroupant plusieurs tailles d'icônes et plusieurs profondeurs de couleur), WinComposer vous propose également, dans son menu contextuel, d'enregistrer individuellement chacune des images affichées sur l'onglet Assembleur d'icônes.

Icône sélectionnée
La sauvegarde individuelle porte sur l'icône sélectionnée, à savoir celle dont la case est entourée d'un cadre vert clair.

Formats proposés
WinComposer propose les formats d'enregistrement suivants :

  • Fichier bitmap (BMP),
  • Fichier JPEG,
  • Fichier icns Mac (données),
  • Fichier icns Mac (ressources),
  • Icône Windows.

Fichier bitmap (BMP)
WinComposer sauve l'icône sélectionnée au format bitmap (extension *.BMP). Ce format sauvegarde la totalité du contenu de l'image (pas de compression, pas de pertes). Le fichier pourra ensuite être ouvert dans tous les programmes graphiques que vous pouvez utiliser.
Retour en haut de la page

Fichier JPEG
WinComposer sauve l'image sélectionnée au format JPEG (extension *.JPG) avec une compression moyenne. Le format JPEG utilise une compression avec pertes. La taille des fichiers est plus petite que dans le cas des fichiers bitmap.
Retour en haut de la page

Fichier icns Mac (données)
L'icône sélectionnée est sauvegardée sous la forme d'une resource icns.
Les icônes stockées dans la branche de données ne peuvent être utilisées que sous Mac OS X. Sinon, l'organisation du fichier et son contenu sont strictement les mêmes que si l'on avait enregistré dans une branche de ressources.
Retour en haut de la page

Fichier icns Mac (ressources)
L'icône sélectionnée est sauvegardée sous la forme d'une resource icns.
Traditionnellement, les icônes Macintosh sont stockées dans la branche de ressources. WinComposer, pour protéger la branche de ressources, la place dans un conteneur MacBinary. L'en-tête du conteneur contient le nom qui sera utilisé pour nommer le fichier après le déballage du conteneur par MacDisk ou MacImage.
Retour en haut de la page

Icône Windows (ICO)
L'icône sélectionnée est sauvée sous la forme d'un fichier d'icône Windows (extension *.ICO). Le fichier ne contient cette fois qu'une icône, d'une seule taille et d'une seule profondeur de couleur.
Retour en haut de la page

Voir aussi la page consacrée à l'Enregistrement groupé des icônes affichées sur l'onglet Assembleur d'icônes.